var app = {

    restaurantsBrandName: ["Pizza Express", "KFC","McDonald's", "Subway", "Pizza Hut", "Starbucks", "Burger King",
                           "Domino's Pizza", "Dunkin' Donuts", "Dairy Queen","Papa John's", "Telepizza", "Supermac's",
                           "Nando's", "Hesburger", "Chicken Cottage", "Applebee's", "Arby's", "Bonchon Chicken",
                           "Buffalo Wild Wings", "Carl's Jr.", "Charley's Grilled Subs", "Chili's", "Chick-fil-A", "Chipotle Mexican Grill",
                           "Corner Bakery Cafe", "Coffeeheaven", "Costa Coffee", "Crepes & Waffles", "Denny's", "Din Tai Fung",
                           "Gloria Jean's Coffee", "Hamburguesas El Corra", "Hard Rock Cafe", "Hardee's", "Hooters", "In-N-Out Burger",
                           "Jack in the Box", "Jollibee", "Juan Valdez Cafe", "Taco Bell", "Quiznos", "Sonic Drive-In",
                           "Paris Baguette", "Little Caesars", "Popeyes Chicken & Biscuits",
                           "Wendy's", "Yoshinoya", "Panera Bread", "Yogen Fruz", "Krispy Kreme", "Outback Steakhouse", "Ruby Tuesday", 
                           "T.G.I. Friday's", "Red Lobster", "Olive Garden", "Steak 'n Shake", "Perkins Restaurant & Bakery", "Red Robin", 
                           "Shakey's Pizza", "Pollo Campero", "Sizzler", "Tony Roma's", "Marrybrown", "Sweet Frog", "Sarku Japan", "Ponderosa Steakhouse",
                           "Loving Hut", "Secret Recipe", "Dome Coffee", "Rainforest Cafe", "Bonanza Steakhouse", "Jack Astor's Bar & Grill", "Swensen's",
                           "Kenny Rogers Roasters", "The Keg", "Planet Hollywood", "MOS Burger", "Delifrance", "Old Country Buffet",
                           "pizza", "burger","cafe","restauracja", "restaurant","ресторан","مطعم","ravintola","restaurante","ร้านอาหาร","Kneipe","pub","حانة","паб", "restavracija","bar","night club", "klub nocny", "nočni klub","Gostilna","Hitra hrana","Kavarna", "sushi"],

    restaurantsTitleName: ["Express", "KFC","Donald", "Subway", "Pizza Hut", "Starbucks", "Burger King",
                           "Domino", "Dunkin", "Dairy","Papa", "Telepizza", "Supermac",
                           "Nando's", "Hesburger", "Chicken Cottage", "Applebee's", "Arby's", "Bonchon",
                           "Buffalo", "Carl", "Charley", "Chili", "Chick", "Chipotle",
                           "Corner", "heaven", "Costa", "Waffles", "Denny's", "Din Tai Fung",
                           "Gloria", "Corra", "Hard Rock Cafe", "Hardee's", "Hooters", "Burger",
                           "Jack in the Box", "Jollibee", "Juan Valdez Cafe", "Taco Bell", "Quiznos", "Sonic",
                            "Paris Baguette", "Little Caesars", "Popeye",
                            "Wendy's", "Yoshinoya", "Bread", "Yogen Fruz", "Krispy Kreme", "Outback Steakhouse", "Ruby Tuesday", 
                           "Friday", "Red Lobster", "Olive Garden", "Steak 'n Shake", "Perkins", "Red Robin", 
                           "Shakey's", "Pollo Campero", "Sizzler", "Tony Roma's", "Marrybrown", "SweetFrog", "Sarku Japan", "Ponderosa Steakhouse",
                           "Loving Hut", "Secret Recipe", "Dome Cafe", "Rainforest Cafe", "Bonanza", "Jack Astor's Bar & Grill", "Swensen's",
                           "Kenny Rogers Roasters","The Keg", "Planet Hollywood", "MOS Burger", "Delifrance", "Old Country Buffet",
                           "pizz","burger","cafe","","","","","","","","","","","","","","","","","","","",""],

    longTail : 22,
    storageValidytyPeriod: 60, // days
    maxRadius: 20000, // radius in meters - if we are close enoiught then saved list from storage will be used
    imgSize: 48,
    iconsVisible: false,
    defaultTimeOut: 100,
    longTimeOut: 800,
    maxAge : 60*60*1000,
    gpsTimeout: 10*1000,
    googleVisiting: false,
    geocoder: new google.maps.Geocoder(),
    language:null,
    nearDistance: 200, //meters - if restaurants are closer than this distance then are presented as close to each other
    dataStructureVersion: 21, // if we change structure of data written to local storage we need to increment this value
    defaultAddress : "Wrocław, Polska",
    defaultAddressSL : "Ljubljana, Slovenija",
    defaultAddressDE : "Berlin, Deutschland",
    defaultAddressCZ : "Praha, České republiky",
    defaultAddressRO : "București, România",
    
    currentRestaurantID : -1,
    map: null,
    restaurantCounter : 0,
    allPlaces : [],
    userStartingPosition : null,
    directionsService : null,
    directionsDisplay : null,
    internal_counter : 0,
    bugout : null,
    


    // Application Constructor
    initialize: function() {
        document.addEventListener("deviceready", app.onDeviceReady, false);
        browserModule.runIfNotMobile();
    },

    onDeviceReady: function() {
        //app.bugout  = new debugout();
        tabsModule.init();
        if (typeof (navigator.globalization) == "undefined") {
            //console.log("navigator.globalization = undefined");
            app.language = "en";
            localeModule.getLanguage();
            return;
        }
        navigator.globalization.getLocaleName(  function (locale) {
                                                    app.language = locale.value.substr(0,2);
                                                    localeModule.getLanguage();
                                                },
                                                function () {
                                                    app.language = "en";
                                                    localeModule.getLanguage();
                                                });
    }

};

var localeModule = (function() {

    function loadMessages() {
        $("textarea#dialog1").val(msg_dialog1_content)
        $("#dialog1").dialog("option", "title", msg_give_current_address);
        //$("#dialog2").dialog("option", "title", msg_give_new_address);
        $(".ui-button-text:contains(Save)").text(msg_button_save);
        $(".ui-button-text:contains(Cancel)").text(msg_button_cancel);
        $("textarea#feedbackarea").text(msg_textarea_feedback_content);
        $("a[href$='#tabs-1']").text(msg_tab_1_near_you);
        $("a[href$='#tabs-2']").text(msg_tab_2_map);
        $("a[href$='#tabs-3']").text(msg_button_my_address);
        $("#center_map_button").text(msg_button_center_map);
        $("#my_address_button").text(msg_button_my_address);
        $("#toggle_icons_button").text(msg_button_toggle_icons);
        $('#mode option[value="WALKING"]').text(msg_transport_option_walking);
        $('#mode option[value="DRIVING"]').text(msg_transport_option_driving);
        $('#mode option[value="BICYCLING"]').text(msg_transport_option_bicycling);
        $('#goingMode option[value="WALKING"]').text(msg_transport_option_walking);
        $('#goingMode option[value="DRIVING"]').text(msg_transport_option_driving);
        $('#goingMode option[value="BICYCLING"]').text(msg_transport_option_bicycling);
        $("#mode_text").text(msg_mode + ":");
        $("#msg_speed_mode").text(msg_mode + " ");
        $("#feedback_text").text(msg_tab_3_feedback);
        $("#send_mail_button").text(msg_button_send_mail);
    }

    function startAppAfterLanguageLoad(){
        settingsModule.setBanerAndDefaultAddress();
        viewModule.renderWelcomeMessage();
        viewModule.renderButtons();
        loadMessages();
        searchModule.getUserPosition();
    }

    function getLanguage() {
        $.i18n.properties({
                            name:'Messages', 
                            path:'i18n/', 
                            mode:'both',
                            language: app.language,
                            callback: startAppAfterLanguageLoad
        });
    }

    return {
        getLanguage:getLanguage,
    }

}());

var settingsModule = (function() {

    function setBanerAndDefaultAddress() {
        var banerLink = "http://mfirma.de";
        var banerImg = "img/mfirmade.png";

        switch (app.language) {
            case "de":
                app.defaultAddress = app.defaultAddressDE;
                break;
            case "pl": {
                banerLink = "http://pl.mfirma.eu";
                banerImg = "img/mfirmapl.png";
                break;
            }
            case "sl": {
                banerLink = "http://web5.si";
                banerImg = "img/web5si.png";
                app.defaultAddress = app.defaultAddressSL;
                break;
            }
            case "sk":
            case "cs": {
                banerLink = "http://mfirma.cz";
                banerImg = "img/mfirmacz.png";
                app.defaultAddress = app.defaultAddressCZ;
                break;
            }
            case "ro": {
                banerLink = "http://mfirma.ro";
                banerImg = "img/mfirmaro.png";
                app.defaultAddress = app.defaultAddressRO;
                break;
            }
            case "ru":
            case "kk":
            case "mn":{
                banerLink = "http://mfirma.com.ru";
                banerImg = "img/mfirmaru.png";
                break;
            }
            case "uk":{
                banerLink = "http://mfirma.com.ua";
                banerImg = "img/mfirmaua.png";
                break;
            }
        }

        app.userAddress = app.defaultAddress;
        document.getElementById("banerlink").setAttribute('href',banerLink);
        document.getElementById("banerimg").setAttribute('src',banerImg);
    }
    
    function downloadLog () {
        var file = "data:text/plain;charset=utf-8,";
        var logFile = app.bugout.getLog();
        var encoded = encodeURIComponent(logFile);
        file += encoded;

        var a = document.createElement('a');
        a.href = file;
        a.target = '_blank';
        a.download = 'debugout_log.txt';
        document.body.appendChild(a);
        a.click();
        a.remove();
    }

    return {
        setBanerAndDefaultAddress:setBanerAndDefaultAddress,
        downloadLog:downloadLog,
    }

}());

var myPlaceFactory = (function() {

    // used as object prototype to hold user current location data
    function myPlace(name, address, lat, lng, brand, imageURL){
        this.name = name;
        this.address = address;
        this.lat = lat;
        this.lng = lng;
        this.brand = brand;

        if (typeof(imageURL)==="undefined") {
            this.imageURL = "img/" + this.brand.replace(".","").replace("'","")
            .replace("&","").replace("&","").replace(" ","").replace(" ","")
            .replace(" ","").replace(" ","").replace(" ","")
            .toLowerCase() + ".png";
        } else {
            this.imageURL = imageURL;
        }

        this.getDistance = getDistance;
        function getDistance(positionLatLon) {
            return mathToolsModule.LatLonToDistance( 
                                                    positionLatLon.lat(),
                                                    positionLatLon.lng(),
                                                    this.lat,
                                                    this.lng )
        };

        this.getWalkingTime = getWalkingTime;
        function getWalkingTime(positionLatLon){
            var speedUnit = document.getElementById("goingMode").value;
            switch (speedUnit) {
                case "WALKING":
                    var rate = 0.012 / 1;
                    break;
                case "DRIVING":
                    var rate = 0.012 / 12;
                    break;
                case "BICYCLING":
                    var rate = 0.012 / 3;
                    break;
            }
            return (this.getDistance(positionLatLon) * rate).toFixed(0);
        };
    };

    function produce(name, address, lat, lng, brand, imageURL) {
        return new myPlace(name, address, lat, lng, brand, imageURL);
    }

    return {
        produce:produce
    }

}());

var searchModule = (function() {

    function getUserPosition() {
        if (app.googleVisiting) {
            localStorageModule.load();
            return;
        }

        if(navigator.geolocation) {
            //console.log("navigator.geolocation true");
            navigator.geolocation.getCurrentPosition(geoCallbackSucess, geoCallbackFail,
                                                    {
                                                        maximumAge: app.maxAge,
                                                        timeout: app.gpsTimeout, 
                                                        enableHighAccuracy: true
                                                    }
            );
        } else {
            //console.log("navigator.geolocation false");
            geoCallbackFail();
        }
    }

    function geoCallbackSucess(position) {
        //console.log("geoCallbackSucess");
        var userLatLng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
        app.geocoder.geocode({'location': userLatLng}, 
                        function(results, status) {
                            
                            if (status == google.maps.GeocoderStatus.OVER_QUERY_LIMIT ) {
                                window.setTimeout("geoCallbackSucess(position)", longTimeOut);
                                return;
                            }
                            
                            if (status == google.maps.GeocoderStatus.OK)
                                app.userAddress = results[0].formatted_address;
                            else
                                app.userAddress = msg_position_not_defined;
                        
                            viewModule.setAddressInDialog(app.userAddress);
                            viewModule.getOrConfirmAddressFromUser();
                        });
    }

    function geoCallbackFail (error) {
        //console.log("geoCallbackFail: "); console.log(error);
        
        app.userAddress = "";
        viewModule.setAddressInDialog(app.userAddress);
        viewModule.getOrConfirmAddressFromUser();
    }

    function searchNearbyBasedOnUserAddress() {
        app.geocoder.geocode( { 'address': app.userAddress}, function(results, status) {
            if (status == google.maps.GeocoderStatus.OK) {
                viewModule.setUserPositionCreateMap(results[0].geometry.location);
                if (!localStorageModule.load()) {
                    startSearchingNearRestaurants();
                    return;
                }
                viewModule.showRestaurantsOnScreen();
                return;
                } else {
                    //console.log("searchNearbyBasedOnUserAddress: " + status);
                    alert(msg_impossible_read_address);
                    viewModule.setAddressInDialog(app.userAddress);
                    viewModule.getOrConfirmAddressFromUser();
            }});
    }

    function searchNearRestaurants(name) {
        //console.log("brand index: " + app.restaurantCounter + " from " + app.restaurantsBrandName.length + " restaurants");
        //console.log("Brand: " + name);
        var request = {
            location: app.userStartingPosition,
            radius: '20000',
            query  : name,
        };
        service = new google.maps.places.PlacesService(app.map);
        service.textSearch(request, restaurantsSearchCallback);
        viewModule.renderProgress(name);
    }
    
    function startSearchingNearRestaurants () {
        app.restaurantCounter = 0;
        app.total = app.restaurantsBrandName.length;
        var name = app.restaurantsBrandName[app.restaurantCounter];
        searchNearRestaurants(name);
    }
    

    function isFoodPlace(types) {
        if ((types.length == 1) && (types[0] == "establishment")) {
            return true; // might generate fals positives buts its better than false negaitve errors
        }
        for (i=0; i < types.length - 1; i++) {
            if (types[i] == "restaurant" || types[i] == "food" || types[i] == "bar" || types[i] == "cafe" || types[i] == "bar" || types[i] == "meal_takeaway") {
                return  true;
            }
        }
        return false;
    }

    function isHotelOrOtherWrongPlace(types) {
        for (i=0; i < types.length - 1; i++) {
            if (types[i] == "spa" || types[i] == "gym" || types[i] == "grocery_or_supermarket" || types[i] == "lodging" || types[i] == "storage" || types[i] == "store") {
                return  true;
            }
        }
        return false;
    }

    function restaurantsSearchCallback(results, status, pagination) {
        if (status !== google.maps.places.PlacesServiceStatus.OK) {
            //console.log("restaurantsSearchCallback: " + status);
            if (status == google.maps.places.PlacesServiceStatus.ZERO_RESULTS) {
                app.restaurantCounter++;
                ++app.internal_counter;
                window.setTimeout("searchModule.searchNearRestaurants(app.restaurantsBrandName[app.restaurantCounter])",app.defaultTimeOut);
            }
            if (status == google.maps.places.PlacesServiceStatus.OVER_QUERY_LIMIT) {
                window.setTimeout("searchModule.searchNearRestaurants(app.restaurantsBrandName[app.restaurantCounter])",app.longTimeOut);
                return;
            }
        } else {
            var local_counter = results == null ? 0 : results.length;
            var brandReg = new RegExp(app.restaurantsTitleName[app.restaurantCounter], "i");
            
            if (pagination.hasNextPage) {
                    app.total++;
            }

            for (var i = 0; i < results.length; i++) {
                var restaurantName = results[i].name;
                var restaurantAddress = results[i].formatted_address;
                if (restaurantName.search(brandReg) != -1 || app.restaurantsTitleName[app.restaurantCounter] == "") {
                    var placeObj = myPlaceFactory.produce( restaurantName,
                                                            restaurantAddress,
                                                            results[i].geometry.location.lat(),
                                                            results[i].geometry.location.lng(),
                                                            app.restaurantsBrandName[app.restaurantCounter]
                                                            );
                    
                    if (app.restaurantCounter >= app.restaurantsBrandName.length-1-app.longTail &&
                                                                                        typeof(results[i].types) !== "undefined" &&
                                                                                        isFoodPlace(results[i].types) &&
                                                                                        !isHotelOrOtherWrongPlace(results[i].types)) {
                        placeObj.brand = restaurantName;
                        placeObj.imageURL = results[i].icon;
                        if (typeof(results[i].photos) !== "undefined") {
                            placeObj.imageURL = results[i].photos[0].getUrl({maxWidth:96});
                        }
                        app.allPlaces.push(placeObj);
                        //app.bugout.log("Added;" + app.restaurantsBrandName[app.restaurantCounter] + ";" + brandReg + ";" + restaurantName + ";" + restaurantAddress.replace(/(,|;)/gi, " "));
                    } else if (app.restaurantCounter < app.restaurantsBrandName.length-1-app.longTail) {
                        app.allPlaces.push(placeObj);
                        //app.bugout.log("Added;" + app.restaurantsBrandName[app.restaurantCounter] + ";" + brandReg + ";" + restaurantName + ";" + restaurantAddress.replace(/(,|;)/gi, " "));
                    } else {
                        //app.bugout.log("NOT added (type);" + ";" + app.restaurantsBrandName[app.restaurantCounter] + ";" + brandReg + ";" + restaurantName + ";" + restaurantAddress.replace(/(,|;)/gi, " "));
                    }
                } else {
                    //app.bugout.log("NOT added (brand);" + app.restaurantsBrandName[app.restaurantCounter] + ";" + brandReg + ";" + restaurantName + ";" + restaurantAddress.replace(/(,|;)/gi, " "));
                }

                if (--local_counter === 0) {
                        if (++app.internal_counter === app.total) {
                            localStorageModule.save();
                            viewModule.showRestaurantsOnScreen();
                        }
                }
            }

            if (pagination.hasNextPage) {
                //tu powinien być sleep 2 sekundy
                //console.log("pagination.hasNextPage");
                window.setTimeout(function(){ 
                                                pagination.nextPage();
                                            }, 2000);
            } else {
                app.restaurantCounter++;
                if (app.restaurantCounter == app.restaurantsBrandName.length) {
                    localStorageModule.save();
                    viewModule.showRestaurantsOnScreen();
                } else  {
                    window.setTimeout("searchModule.searchNearRestaurants(app.restaurantsBrandName[app.restaurantCounter])",app.defaultTimeOut);
                }
            }
        }
    }

    return {
        searchNearbyBasedOnUserAddress:searchNearbyBasedOnUserAddress,
        getUserPosition:getUserPosition,
        searchNearRestaurants:searchNearRestaurants,
    }

}());

var localStorageModule = (function() {

    function save() {
        if(typeof(Storage) !== "undefined" && typeof(JSON) !== "undefined") {
            localStorage["DATA_STRUCTURE_VERSION"] = app.dataStructureVersion;
            var JSONPosition = {};
            JSONPosition["lat"] = app.userStartingPosition.lat();
            JSONPosition["lng"] = app.userStartingPosition.lng();
            localStorage["app.userStartingPosition"] = JSON.stringify(JSONPosition);
            localStorage["app.allPlaces"] = JSON.stringify(app.allPlaces);
            localStorage["date"] = new Date().toUTCString();
            localStorage["restaurantsBrandNameLength"] = app.restaurantsBrandName.length;
            localStorage["app.userAddress"] = app.userAddress;
        }
    }

    function load() {
        if(typeof(Storage)!== "undefined" && typeof(JSON) !== "undefined") {
            var JSONallPlaces;
            var pastUserAddress;
            var JSONstartingPosition;
            var dataStr;
            var restaurantsBrandNameLength;
            var dataStructureVersion;

            if (app.googleVisiting) {
                JSONstartingPosition = JSON.stringify(new google.maps.LatLng (52.52000659999999, 13.404953999999975));
                JSONallPlaces = "[]";
                restaurantsBrandNameLength = app.restaurantsBrandName.length;
                dataStr = "";
            } else {
                JSONallPlaces = localStorage["app.allPlaces"];        
                JSONstartingPosition = localStorage["app.userStartingPosition"];
                dataStr = localStorage["date"];
                restaurantsBrandNameLength = parseInt(localStorage["restaurantsBrandNameLength"]); // to update list also if there are new restaurants added to app
                dataStructureVersion = parseInt(localStorage["DATA_STRUCTURE_VERSION"]);
            }

            if (typeof(JSONallPlaces) !== "undefined" &&
                typeof(JSONstartingPosition) !== "undefined" &&
                typeof(dataStr) !== "undefined" &&
                typeof(restaurantsBrandNameLength) !== "undefined" &&
                typeof(dataStructureVersion) !== "undefined" &&
                dataStructureVersion == app.dataStructureVersion &&
                restaurantsBrandNameLength == app.restaurantsBrandName.length) {
                
                var pastPositionObj = jQuery.parseJSON(JSONstartingPosition);
                var pastPosition = new google.maps.LatLng (pastPositionObj.lat, pastPositionObj.lng);
                var daysFromLastSave;
                var dist;

                if (app.googleVisiting || app.userStartingPosition == null) {
                    dist = 0;
                    daysFromLastSave = 0;
                    app.userStartingPosition = pastPosition;
                } else {
                    dist = mathToolsModule.LatLonToDistance(pastPosition.lat(),
                                                      pastPosition.lng(),
                                                      app.userStartingPosition.lat(),
                                                      app.userStartingPosition.lng());
                    daysFromLastSave = Math.abs(((new Date() - Date.parse(dataStr)) / 86400000).toFixed(0));
                }

                if (dist <= app.maxRadius && daysFromLastSave < app.storageValidytyPeriod) {
                    var pastList = jQuery.parseJSON(JSONallPlaces);
                    app.allPlaces = [];
                    for (i=0; i < pastList.length; i++) {
                        var placeObj = myPlaceFactory.produce(pastList[i].name,
                                                               pastList[i].address,
                                                               pastList[i].lat,
                                                               pastList[i].lng,
                                                               pastList[i].brand,
                                                               pastList[i].imageURL
                                                               );
                        app.allPlaces.push(placeObj);
                    }
                    app.allPlaces.sort(function(a,b){return a.getDistance(app.userStartingPosition) - b.getDistance(app.userStartingPosition)});
                    return  true;
                }
            }
        }

        return false;
    }

    return {
        save:save,
        load:load,
    }

}());

var viewModule = (function() {

    function renderButtons() {
        $( "button" ).button();
        $( "#dialog1" ).dialog({
            autoOpen: false,
            modal: true,
            closeOnEscape: false,
            position: { my: 'top', at: 'top+50' },
            open: function(event, ui) { $(".ui-dialog-titlebar-close", ui.dialog || ui).hide(); },
            close : function () {},
            buttons: {
                Cancel: function() { $( this ).dialog( "close" ); },
                Save: function() {
                    app.userAddress = $('#address1').val();
                    searchModule.searchNearbyBasedOnUserAddress();
                    $( "#tabHeader_1" ).click();
                    $( this ).dialog( "close" );
                    }
                }
            });
        $('#address1').val(app.userAddress);
        document.getElementById("mybody").style.visibility = "visible";
    }

    function createEmailLink() {
        var link = [
            'mailto:biuro@primagia.pl',
            '?subject=' + encodeURIComponent(msg_mail_subject),
            '&body=' + encodeURIComponent(document.getElementById('feedbackarea').value),
            ].join(' ');

        window.location.href = link;
    }

    function getOrConfirmAddressFromUser() {
        $( "#dialog1" ).dialog("open");
    }

    function removeDuplicatedPlaces() {
        
        //app.bugout  = new debugout();
        
        if (app.allPlaces.length <= 1) {
            return;
        }
        var uniqueArray = new Array();
        for (var i = 0; i <= app.allPlaces.length-2; i++) {
            if (app.allPlaces[i].name != app.allPlaces[i+1].name ||
                app.allPlaces[i].address != app.allPlaces[i+1].address) {
                uniqueArray.push(app.allPlaces[i]);
                //app.bugout.log("added;" + app.allPlaces[i].name + ";" + app.allPlaces[i].address);
            } else {
                //app.bugout.log("removed;" + app.allPlaces[i].name + ";" + app.allPlaces[i].address);
            }   
        } 

        if (app.allPlaces[app.allPlaces.length-1].name != app.allPlaces[app.allPlaces.length-1-1].name ||
            app.allPlaces[app.allPlaces.length-1].address != app.allPlaces[app.allPlaces.length-1-1].address) {
            uniqueArray.push(app.allPlaces[app.allPlaces.length-1]);
            //app.bugout.log("added;" + app.allPlaces[app.allPlaces.length-1].name + ";" + app.allPlaces[app.allPlaces.length-1].address);
        } else {
                //app.bugout.log("removed;" + app.allPlaces[app.allPlaces.length-1].name + ";" + app.allPlaces[app.allPlaces.length-1].address);
        } 
        app.allPlaces = uniqueArray;
        //settingsModule.downloadLog();
    }

    function renderProgress(name) {
        var resName = name;
        if (app.restaurantCounter >= app.restaurantsBrandName.length-1-app.longTail) {
            resName = msg_local_restaurants;
        }
        var progressMsg = [
                '<div id="welcomeMessage">',
                    msg_welcome,
                '</div>',
                '<center>',
                '<strong>',
                     Math.round(100* app.restaurantCounter / (app.restaurantsBrandName.length-1)) + " % ",
                 '</strong>',
                 '(' + resName + ')',
                 '</center>',
             ].join(' ');
        document.getElementById("addressTable").innerHTML = progressMsg;
    }

    function renderAddressTable() {
        var distanceMode = document.getElementById("distanceMode").value;
        
        
        var html_output = [];
        html_output.push('<table class="addrTable">');
        for (var i = 0; i < app.allPlaces.length; i++) {
            var d = app.allPlaces[i].getDistance(app.userStartingPosition);
            if (d > app.maxRadius) { // we won't show results which are out of radius - googles api bug?
                continue;
            }

            var dStr='';
            if (distanceMode == "km") {
                if (d < 1000) {
                    dStr = d + ' m';
                } else {
                    dStr = (d/1000).toFixed(1) + ' km'
                }
            } else {
                if (d < 1609.3) {
                    dStr = ((5280 *d)/1609.3).toFixed(0) + ' ft';
                } else {
                    dStr = (d/1609.3).toFixed(1) + ' mi'
                }
            }

            var imgName = app.allPlaces[i].imageURL;
            var placeAddress = app.allPlaces[i].address;
            var walkingTime = app.allPlaces[i].getWalkingTime(app.userStartingPosition);
            var placeName = app.allPlaces[i].brand;

            var html_table_row = [
                '<tr onclick=viewModule.showRouteToRestaurant("' + i + '");>',
                    '<td class="variantB" style=width: 3.1em; height: 3.1em" id="foodrow1">',
                        '<img id=brandimg src="' + imgName + '"></img>',
                    '</td>',
                    '<td class="variantB" id="foodrow2" style="width:auto">',
                        '<p class="place__name">' + placeName + '</p>',
                        '<p class="place__address">' + placeAddress + '</p>',
                        '</td>',
                    '<td class="variantB" style="width: 4em" id="foodrow3">',
                         dStr + '<br>',
                         walkingTime + ' min', 
                    '</td>',
                '</tr>',
            ].join(' ');

            html_output.push(html_table_row);
        }

        html_output.push('</table>');
        document.getElementById("addressTable").innerHTML = html_output.join(' ');
    }

    function showRestaurantsOnScreen(){
        app.allPlaces.sort(function(a,b) { return a.getDistance(app.userStartingPosition) - b.getDistance(app.userStartingPosition) });
        removeDuplicatedPlaces();
        
        if (app.map == null) {
            setUserPositionCreateMap(app.userStartingPosition);
            //console.log("app.map == null - czy to sie wykonuje ?");
        }

        app.map.setCenter(app.userStartingPosition);
        renderAddressTable();
        rePaintMap(false);
    }

    function rePaintMap(showMapDivFlag) {
        if (showMapDivFlag) $( "#tabHeader_2" ).click();
        var tabs = $("#tabs").outerHeight(true);
        var mapHeight = "" + (parseInt($(window).height()) - tabs - 1) + "px";
        document.getElementById("mapDiv").style.height = mapHeight;
        setTimeout(function(){
                    setUserPositionCreateMap(app.userStartingPosition);
                   },
                   50);
    }
    
    
    function onChangeTravelMode() {
        document.getElementById("mode").selectedIndex = document.getElementById("goingMode").selectedIndex;
        //console.log("Table: " + document.getElementById("mode").selectedIndex);
        
        renderAddressTable();
    }

    function showRouteToRestaurant(restaurantID) {
        document.getElementById("goingMode").selectedIndex = document.getElementById("mode").selectedIndex;
        
        //console.log("Map: " + document.getElementById("mode").selectedIndex);
         
        if (app.currentRestaurantID == -1 && restaurantID == undefined) return;
        
        if (restaurantID != null) {
            app.currentRestaurantID = restaurantID;
        }
        
        var selectedMode  = document.getElementById('mode').value;

        var request = {
            origin: app.userStartingPosition,
            destination: new google.maps.LatLng (app.allPlaces[app.currentRestaurantID].lat, app.allPlaces[app.currentRestaurantID].lng),
            travelMode: google.maps.TravelMode[selectedMode]
        };
        
        app.directionsService.route(request, function(result, status) {
            if (status == google.maps.DirectionsStatus.OK) {
                app.directionsDisplay.setDirections(result);
                rePaintMap(true);
            }
        });
    }

    function centerMapAndShowRoad() {
        if (app.directionsDisplay != null) app.directionsDisplay.setRouteIndex(0);
    }

    function setUserPositionCreateMap(position) {
        app.userStartingPosition = position;
        app.map = new google.maps.Map(document.getElementById("mapDiv"), {
                mapTypeId: google.maps.MapTypeId.ROADMAP,
                center: app.userStartingPosition,
                zoom: 14,
                mapTypeControl: true,
                mapTypeControlOptions: {
                    style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR,
                    position: google.maps.ControlPosition.BOTTOM_CENTER
                },
                streetViewControl: true,
                streetViewControlOptions: {
                    position: google.maps.ControlPosition.RIGHT_BOTTOM
                },
                zoomControl: true,
                zoomControlOptions: {
                    style: google.maps.ZoomControlStyle.LARGE,
                    position: google.maps.ControlPosition.LEFT_BOTTOM
                },
                });

        if (app.directionsDisplay == null) {
            app.directionsService = new google.maps.DirectionsService();
            app.directionsDisplay = new google.maps.DirectionsRenderer();
        }

        app.directionsDisplay.setMap(app.map);

        if (app.currentRestaurantID != -1) {
            
            if (app.iconsVisible) {
                for (var i = 0;i<app.allPlaces.length;i++) {
                    if (i != app.currentRestaurantID) {
                        var image = {
                            url: app.allPlaces[i].imageURL,
                            size: null,
                            origin: null,
                            anchor: new google.maps.Point(14,14),
                            scaledSize: new google.maps.Size(28, 28)
                        };
                        var marker = new google.maps.Marker({
                                        position: new google.maps.LatLng(
                                                        app.allPlaces[i].lat, 
                                                        app.allPlaces[i].lng
                                                    ),
                                        map: app.map,
                                        title: app.allPlaces[i].brand,
                                        icon: image,
                                        zIndex:0
                                    });
                    }
                }
            }

            var image = {
                url: app.allPlaces[app.currentRestaurantID].imageURL,
                size: null,
                origin: null,
                anchor: new google.maps.Point(23,(48+6)),
                scaledSize: new google.maps.Size(48, 48)
            };
            var marker = new google.maps.Marker({
                            position: new google.maps.LatLng(
                                        app.allPlaces[app.currentRestaurantID].lat,
                                        app.allPlaces[app.currentRestaurantID].lng
                                      ),
                            map: app.map,
                            title: app.allPlaces[app.currentRestaurantID].brand,
                            icon: image,
                            zIndex:1000,
                            flat: false
                        });
        }
    }

    function toggleIcons() {
        app.iconsVisible = !app.iconsVisible;
        rePaintMap(true);
    }

    function setAddressInDialog(value) {
        $('#address1').val(value);
    }

    function renderWelcomeMessage() {
        document.getElementById("addressTable").innerHTML = msg_welcome;
    }

    return {
        renderButtons:renderButtons,
        createEmailLink:createEmailLink,
        setUserPositionCreateMap:setUserPositionCreateMap,
        showRestaurantsOnScreen:showRestaurantsOnScreen,
        rePaintMap:rePaintMap,
        renderProgress:renderProgress,
        getOrConfirmAddressFromUser:getOrConfirmAddressFromUser,
        setAddressInDialog:setAddressInDialog,
        showRouteToRestaurant:showRouteToRestaurant,
        toggleIcons:toggleIcons,
        renderWelcomeMessage:renderWelcomeMessage,
        onChangeTravelMode:onChangeTravelMode,
    }

}());

var tabsModule = (function() {

    function init() {
        document.addEventListener("menubutton", doMenu, false);
        var container = document.getElementById("tabs");
        var navitem = container.querySelector("#tabs ul li");
        var ident = navitem.id.split("_")[1];

        navitem.parentNode.setAttribute("data-current",ident);
        navitem.setAttribute("class","app-nav active");

        var pages = container.querySelectorAll(".tabpage");
        for (var i = 1; i < pages.length; i++) {
          pages[i].style.display="none";
        }

        var tabs = container.querySelectorAll("#tabs ul li");
        for (var i = 0; i < tabs.length; i++) {
          tabs[i].onclick=displayPage;
        }
    }

    function displayPage() {
        document.getElementById("feedback").style.display="none";
        var current = this.parentNode.getAttribute("data-current");
        document.getElementById("tabHeader_" + current).setAttribute("class","app-nav");
        document.getElementById("tabs-" + current).style.display="none";
        

        var ident = this.id.split("_")[1];
        
        if (ident == 1) {
            document.getElementById("travelModePanel").style.display="block";
        }
        else {
            document.getElementById("travelModePanel").style.display="none";
        }
        
        if (ident == 3) {
          document.getElementById("tabHeader_" + current).setAttribute("class","app-nav active");
          document.getElementById("tabs-" + current).style.display="block";
        } else {
          this.setAttribute("class","app-nav active");
          document.getElementById("tabs-" + ident).style.display="block";
          this.parentNode.setAttribute("data-current",ident);
        }
    }

    function doMenu() {
        document.getElementById("feedback").style.display="block";
        document.getElementById("tabs-1").style.display="none";
        document.getElementById("tabs-2").style.display="none";
    }

    return {
        init:init,
    }

}());

var mailSenderModule = (function() {

    function send() {
        viewModule.createEmailLink();
    }

    return {
        send:send,
    }

}());

var browserModule = (function() {

    function runIfNotMobile() {
        if (document.URL.indexOf ("localrestaurants4you.com") >= 0 || document.URL.indexOf ("file") >= 0) app.onDeviceReady(); 
    }

    return {
        runIfNotMobile:runIfNotMobile,
    }

}());

var mathToolsModule = (function() {

    function deg2rad(deg) {
        return deg * (Math.PI/180)
    }

    /*
     * @return distance in meters
     */
    function LatLonToDistance(lat1,lon1,lat2,lon2) {
      var R = 6371000; // Radius of the earth in m
      var dLat = deg2rad(lat2-lat1);  // deg2rad below
      var dLon = deg2rad(lon2-lon1); 
      var a = Math.sin(dLat/2) * Math.sin(dLat/2) +
        Math.cos(deg2rad(lat1)) * Math.cos(deg2rad(lat2)) * 
        Math.sin(dLon/2) * Math.sin(dLon/2);
      var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a)); 

      return Math.round(R * c);
    }

    return {
        LatLonToDistance:LatLonToDistance,
    }

}());
